<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11.0.9) on Wed Oct 28 16:08:51 UTC 2020 -->
<title>mxCoordinateAssignment (JGraph X 4.2.2 API Specification)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-10-28">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../../jquery/jquery-3.5.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="mxCoordinateAssignment (JGraph X 4.2.2 API Specification)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxCoordinateAssignment.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">import hk.quantr.mxgraph.layout.hierarchical.stage</a></div>
<h2 title="Class mxCoordinateAssignment" class="title">Class mxCoordinateAssignment</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>import hk.quantr.mxgraph.layout.hierarchical.stage.mxCoordinateAssignment</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><code><a href="mxHierarchicalLayoutStage.html" title="interface in import hk.quantr.mxgraph.layout.hierarchical.stage">mxHierarchicalLayoutStage</a></code></dd>
</dl>
<hr>
<pre>public class <span class="typeNameLabel">mxCoordinateAssignment</span>
extends java.lang.Object
implements <a href="mxHierarchicalLayoutStage.html" title="interface in import hk.quantr.mxgraph.layout.hierarchical.stage">mxHierarchicalLayoutStage</a></pre>
<div class="block">Sets the horizontal locations of node and edge dummy nodes on each layer.
 Uses median down and up weighings as well as heuristics to straighten edges as
 far as possible.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="nested.class.summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="memberSummary">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Class</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected class&nbsp;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="mxCoordinateAssignment.AreaSpatialCache.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.stage">mxCoordinateAssignment.AreaSpatialCache</a></span></code></th>
<td class="colLast">
<div class="block">Utility class that stores a collection of vertices and edge points within
 a certain area.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected class&nbsp;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="mxCoordinateAssignment.WeightedCellSorter.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.stage">mxCoordinateAssignment.WeightedCellSorter</a></span></code></th>
<td class="colLast">
<div class="block">A utility class used to track cells whilst sorting occurs on the weighted
 sum of their connected edges.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- =========== FIELD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Field</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#channelBuffer">channelBuffer</a></span></code></th>
<td class="colLast">
<div class="block">The size of the vertical buffer in the center of inter-rank channels
 where edge control points should not be placed</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#currentXDelta">currentXDelta</a></span></code></th>
<td class="colLast">
<div class="block">The sum of x-displacements for the current iteration</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#disableEdgeStyle">disableEdgeStyle</a></span></code></th>
<td class="colLast">
<div class="block">Specifies if the STYLE_NOEDGESTYLE flag should be set on edges that are
 modified by the result.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected import hk.quantr.mxgraph.layout.hierarchical.stage.mxCoordinateAssignment.HierarchicalEdgeStyle</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#edgeStyle">edgeStyle</a></span></code></th>
<td class="colLast">
<div class="block">The style to apply between cell layers to edge segments</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#fineTuning">fineTuning</a></span></code></th>
<td class="colLast">
<div class="block">Whether or not to perform local optimisations and iterate multiple times
 through the algorithm</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#groupPadding">groupPadding</a></span></code></th>
<td class="colLast">
<div class="block">Padding added to resized parents</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#initialX">initialX</a></span></code></th>
<td class="colLast">
<div class="block">The minimum x position node placement starts at</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#interRankCellSpacing">interRankCellSpacing</a></span></code></th>
<td class="colLast">
<div class="block">The minimum distance between cells on adjacent ranks</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#intraCellSpacing">intraCellSpacing</a></span></code></th>
<td class="colLast">
<div class="block">The minimum buffer between cells on the same rank</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected java.util.Map&lt;<a href="../model/mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>,&#8203;double[]&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#jettyPositions">jettyPositions</a></span></code></th>
<td class="colLast">
<div class="block">Map of internal edges and (x,y) pair of positions of the start and end jetty
 for that edge where it connects to the source and target vertices.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected <a href="../mxHierarchicalLayout.html" title="class in import hk.quantr.mxgraph.layout.hierarchical">mxHierarchicalLayout</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#layout">layout</a></span></code></th>
<td class="colLast">
<div class="block">Reference to the enclosing layout algorithm</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#limitX">limitX</a></span></code></th>
<td class="colLast">
<div class="block">The maximum x value this positioning lays up to</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#maxIterations">maxIterations</a></span></code></th>
<td class="colLast">
<div class="block">The number of heuristic iterations to run</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#minEdgeJetty">minEdgeJetty</a></span></code></th>
<td class="colLast">
<div class="block">The minimum distance for an edge jetty from a vertex</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected <a href="../model/mxGraphAbstractHierarchyCell.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphAbstractHierarchyCell</a>[][]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#nextLayerConnectedCache">nextLayerConnectedCache</a></span></code></th>
<td class="colLast">
<div class="block">A store of connections to the layer above for speed</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#orientation">orientation</a></span></code></th>
<td class="colLast">
<div class="block">The position of the root ( start ) node(s) relative to the rest of the
 laid out graph</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#parallelEdgeSpacing">parallelEdgeSpacing</a></span></code></th>
<td class="colLast">
<div class="block">The distance between each parallel edge on each ranks for long edges</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#prefHozEdgeSep">prefHozEdgeSep</a></span></code></th>
<td class="colLast">
<div class="block">The preferred horizontal distance between edges exiting a vertex</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#prefVertEdgeOff">prefVertEdgeOff</a></span></code></th>
<td class="colLast">
<div class="block">The preferred vertical offset between edges exiting a vertex</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected <a href="../model/mxGraphAbstractHierarchyCell.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphAbstractHierarchyCell</a>[][]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#previousLayerConnectedCache">previousLayerConnectedCache</a></span></code></th>
<td class="colLast">
<div class="block">A store of connections to the layer below for speed</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected double[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#rankBottomY">rankBottomY</a></span></code></th>
<td class="colLast">
<div class="block">Internal cache of bottom-most value of Y for each rank</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected double[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#rankTopY">rankTopY</a></span></code></th>
<td class="colLast">
<div class="block">Internal cache of top-most values of Y for each rank</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected double[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#rankWidths">rankWidths</a></span></code></th>
<td class="colLast">
<div class="block">The width of all the ranks</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected double[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#rankY">rankY</a></span></code></th>
<td class="colLast">
<div class="block">The Y-coordinate of all the ranks</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#vertexConnectionBuffer">vertexConnectionBuffer</a></span></code></th>
<td class="colLast">
<div class="block">The buffer on either side of a vertex where edges must not connect.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#widestRank">widestRank</a></span></code></th>
<td class="colLast">
<div class="block">The rank that has the widest x position</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#widestRankValue">widestRankValue</a></span></code></th>
<td class="colLast">
<div class="block">The X-coordinate of the edge of the widest rank</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(import hk.quantr.mxgraph.layout.hierarchical.mxHierarchicalLayout,double,double,int,double,double)">mxCoordinateAssignment</a></span>&#8203;(<a href="../mxHierarchicalLayout.html" title="class in import hk.quantr.mxgraph.layout.hierarchical">mxHierarchicalLayout</a>&nbsp;layout,
                      double&nbsp;intraCellSpacing,
                      double&nbsp;interRankCellSpacing,
                      int&nbsp;orientation,
                      double&nbsp;initialX,
                      double&nbsp;parallelEdgeSpacing)</code></th>
<td class="colLast">
<div class="block">Creates a coordinate assignment.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#adjustParents(java.util.Set)">adjustParents</a></span>&#8203;(java.util.Set&lt;java.lang.Object&gt;&nbsp;parentsChanged)</code></th>
<td class="colLast">
<div class="block">Adjust parent cells whose child geometries have changed.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#calculateWidestRank(import hk.quantr.mxgraph.view.mxGraph,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel)">calculateWidestRank</a></span>&#8203;(<a href="../../../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                   <a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model)</code></th>
<td class="colLast">
<div class="block">Calculates the width rank in the hierarchy.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#execute(java.lang.Object)">execute</a></span>&#8203;(java.lang.Object&nbsp;parent)</code></th>
<td class="colLast">
<div class="block">A basic horizontal coordinate assignment algorithm</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getInterRankCellSpacing()">getInterRankCellSpacing</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getIntraCellSpacing()">getIntraCellSpacing</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getLimitX()">getLimitX</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getOrientation()">getOrientation</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#isFineTuning()">isFineTuning</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#localEdgeProcessing(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel)">localEdgeProcessing</a></span>&#8203;(<a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model)</code></th>
<td class="colLast">
<div class="block">Separates the x position of edges as they connect to vertices</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#minPath(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel)">minPath</a></span>&#8203;(<a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model)</code></th>
<td class="colLast">
<div class="block">Straightens out chains of virtual nodes where possible</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#printStatus()">printStatus</a></span>()</code></th>
<td class="colLast">
<div class="block">Utility method to display the x co-ords</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#processReversedEdge(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyEdge,java.lang.Object)">processReversedEdge</a></span>&#8203;(<a href="../model/mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&nbsp;edge,
                   java.lang.Object&nbsp;realEdge)</code></th>
<td class="colLast">
<div class="block">Hook to add additional processing</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#rankCoordinates(int,import hk.quantr.mxgraph.view.mxGraph,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel)">rankCoordinates</a></span>&#8203;(int&nbsp;rankValue,
               <a href="../../../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
               <a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model)</code></th>
<td class="colLast">
<div class="block">Sets up the layout in an initial positioning.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#rankMedianPosition(int,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel,int)">rankMedianPosition</a></span>&#8203;(int&nbsp;rankValue,
                  <a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model,
                  int&nbsp;nextRankValue)</code></th>
<td class="colLast">
<div class="block">Performs median minimisation over one rank.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>protected boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#repositionValid(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphAbstractHierarchyCell,int,double)">repositionValid</a></span>&#8203;(<a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model,
               <a href="../model/mxGraphAbstractHierarchyCell.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphAbstractHierarchyCell</a>&nbsp;cell,
               int&nbsp;rank,
               double&nbsp;position)</code></th>
<td class="colLast">
<div class="block">Determines whether or not a node may be moved to the specified x 
 position on the specified rank</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setCellLocations(import hk.quantr.mxgraph.view.mxGraph,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel)">setCellLocations</a></span>&#8203;(<a href="../../../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                <a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model)</code></th>
<td class="colLast">
<div class="block">Sets the cell locations in the facade to those stored after this layout
 processing step has completed.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setEdgePosition(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphAbstractHierarchyCell)">setEdgePosition</a></span>&#8203;(<a href="../model/mxGraphAbstractHierarchyCell.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphAbstractHierarchyCell</a>&nbsp;cell)</code></th>
<td class="colLast">
<div class="block">Fixes the control points</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setFineTuning(boolean)">setFineTuning</a></span>&#8203;(boolean&nbsp;fineTuning)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setInterRankCellSpacing(double)">setInterRankCellSpacing</a></span>&#8203;(double&nbsp;interRankCellSpacing)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setIntraCellSpacing(double)">setIntraCellSpacing</a></span>&#8203;(double&nbsp;intraCellSpacing)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setLimitX(double)">setLimitX</a></span>&#8203;(double&nbsp;limitX)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setOrientation(int)">setOrientation</a></span>&#8203;(int&nbsp;orientation)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setVertexLocation(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphAbstractHierarchyCell)">setVertexLocation</a></span>&#8203;(<a href="../model/mxGraphAbstractHierarchyCell.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphAbstractHierarchyCell</a>&nbsp;cell)</code></th>
<td class="colLast">
<div class="block">Fixes the position of the specified vertex</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a id="layout">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>layout</h4>
<pre>protected&nbsp;<a href="../mxHierarchicalLayout.html" title="class in import hk.quantr.mxgraph.layout.hierarchical">mxHierarchicalLayout</a> layout</pre>
<div class="block">Reference to the enclosing layout algorithm</div>
</li>
</ul>
<a id="intraCellSpacing">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>intraCellSpacing</h4>
<pre>protected&nbsp;double intraCellSpacing</pre>
<div class="block">The minimum buffer between cells on the same rank</div>
</li>
</ul>
<a id="interRankCellSpacing">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>interRankCellSpacing</h4>
<pre>protected&nbsp;double interRankCellSpacing</pre>
<div class="block">The minimum distance between cells on adjacent ranks</div>
</li>
</ul>
<a id="parallelEdgeSpacing">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>parallelEdgeSpacing</h4>
<pre>protected&nbsp;double parallelEdgeSpacing</pre>
<div class="block">The distance between each parallel edge on each ranks for long edges</div>
</li>
</ul>
<a id="vertexConnectionBuffer">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>vertexConnectionBuffer</h4>
<pre>protected&nbsp;double vertexConnectionBuffer</pre>
<div class="block">The buffer on either side of a vertex where edges must not connect.</div>
</li>
</ul>
<a id="maxIterations">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>maxIterations</h4>
<pre>protected&nbsp;int maxIterations</pre>
<div class="block">The number of heuristic iterations to run</div>
</li>
</ul>
<a id="prefHozEdgeSep">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>prefHozEdgeSep</h4>
<pre>protected&nbsp;int prefHozEdgeSep</pre>
<div class="block">The preferred horizontal distance between edges exiting a vertex</div>
</li>
</ul>
<a id="prefVertEdgeOff">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>prefVertEdgeOff</h4>
<pre>protected&nbsp;int prefVertEdgeOff</pre>
<div class="block">The preferred vertical offset between edges exiting a vertex</div>
</li>
</ul>
<a id="minEdgeJetty">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>minEdgeJetty</h4>
<pre>protected&nbsp;int minEdgeJetty</pre>
<div class="block">The minimum distance for an edge jetty from a vertex</div>
</li>
</ul>
<a id="channelBuffer">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>channelBuffer</h4>
<pre>protected&nbsp;int channelBuffer</pre>
<div class="block">The size of the vertical buffer in the center of inter-rank channels
 where edge control points should not be placed</div>
</li>
</ul>
<a id="jettyPositions">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>jettyPositions</h4>
<pre>protected&nbsp;java.util.Map&lt;<a href="../model/mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>,&#8203;double[]&gt; jettyPositions</pre>
<div class="block">Map of internal edges and (x,y) pair of positions of the start and end jetty
 for that edge where it connects to the source and target vertices.
 Note this should technically be a WeakHashMap, but since JS does not
 have an equivalent, housekeeping must be performed before using.
 i.e. check all edges are still in the model and clear the values.
 Note that the y co-ord is the offset of the jetty, not the
 absolute point</div>
</li>
</ul>
<a id="orientation">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>orientation</h4>
<pre>protected&nbsp;int orientation</pre>
<div class="block">The position of the root ( start ) node(s) relative to the rest of the
 laid out graph</div>
</li>
</ul>
<a id="initialX">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>initialX</h4>
<pre>protected&nbsp;double initialX</pre>
<div class="block">The minimum x position node placement starts at</div>
</li>
</ul>
<a id="limitX">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>limitX</h4>
<pre>protected&nbsp;double limitX</pre>
<div class="block">The maximum x value this positioning lays up to</div>
</li>
</ul>
<a id="currentXDelta">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>currentXDelta</h4>
<pre>protected&nbsp;double currentXDelta</pre>
<div class="block">The sum of x-displacements for the current iteration</div>
</li>
</ul>
<a id="widestRank">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>widestRank</h4>
<pre>protected&nbsp;int widestRank</pre>
<div class="block">The rank that has the widest x position</div>
</li>
</ul>
<a id="rankTopY">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rankTopY</h4>
<pre>protected&nbsp;double[] rankTopY</pre>
<div class="block">Internal cache of top-most values of Y for each rank</div>
</li>
</ul>
<a id="rankBottomY">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rankBottomY</h4>
<pre>protected&nbsp;double[] rankBottomY</pre>
<div class="block">Internal cache of bottom-most value of Y for each rank</div>
</li>
</ul>
<a id="widestRankValue">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>widestRankValue</h4>
<pre>protected&nbsp;double widestRankValue</pre>
<div class="block">The X-coordinate of the edge of the widest rank</div>
</li>
</ul>
<a id="rankWidths">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rankWidths</h4>
<pre>protected&nbsp;double[] rankWidths</pre>
<div class="block">The width of all the ranks</div>
</li>
</ul>
<a id="rankY">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rankY</h4>
<pre>protected&nbsp;double[] rankY</pre>
<div class="block">The Y-coordinate of all the ranks</div>
</li>
</ul>
<a id="fineTuning">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>fineTuning</h4>
<pre>protected&nbsp;boolean fineTuning</pre>
<div class="block">Whether or not to perform local optimisations and iterate multiple times
 through the algorithm</div>
</li>
</ul>
<a id="disableEdgeStyle">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>disableEdgeStyle</h4>
<pre>protected&nbsp;boolean disableEdgeStyle</pre>
<div class="block">Specifies if the STYLE_NOEDGESTYLE flag should be set on edges that are
 modified by the result. Default is true.</div>
</li>
</ul>
<a id="edgeStyle">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>edgeStyle</h4>
<pre>protected&nbsp;import hk.quantr.mxgraph.layout.hierarchical.stage.mxCoordinateAssignment.HierarchicalEdgeStyle edgeStyle</pre>
<div class="block">The style to apply between cell layers to edge segments</div>
</li>
</ul>
<a id="nextLayerConnectedCache">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>nextLayerConnectedCache</h4>
<pre>protected&nbsp;<a href="../model/mxGraphAbstractHierarchyCell.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphAbstractHierarchyCell</a>[][] nextLayerConnectedCache</pre>
<div class="block">A store of connections to the layer above for speed</div>
</li>
</ul>
<a id="groupPadding">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>groupPadding</h4>
<pre>protected&nbsp;int groupPadding</pre>
<div class="block">Padding added to resized parents</div>
</li>
</ul>
<a id="previousLayerConnectedCache">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>previousLayerConnectedCache</h4>
<pre>protected&nbsp;<a href="../model/mxGraphAbstractHierarchyCell.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphAbstractHierarchyCell</a>[][] previousLayerConnectedCache</pre>
<div class="block">A store of connections to the layer below for speed</div>
</li>
</ul>
</li>
</ul>
</section>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;(import hk.quantr.mxgraph.layout.hierarchical.mxHierarchicalLayout,double,double,int,double,double)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>mxCoordinateAssignment</h4>
<pre>public&nbsp;mxCoordinateAssignment&#8203;(<a href="../mxHierarchicalLayout.html" title="class in import hk.quantr.mxgraph.layout.hierarchical">mxHierarchicalLayout</a>&nbsp;layout,
                              double&nbsp;intraCellSpacing,
                              double&nbsp;interRankCellSpacing,
                              int&nbsp;orientation,
                              double&nbsp;initialX,
                              double&nbsp;parallelEdgeSpacing)</pre>
<div class="block">Creates a coordinate assignment.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>intraCellSpacing</code> - the minimum buffer between cells on the same rank</dd>
<dd><code>interRankCellSpacing</code> - the minimum distance between cells on adjacent ranks</dd>
<dd><code>orientation</code> - the position of the root node(s) relative to the graph</dd>
<dd><code>initialX</code> - the leftmost coordinate node placement starts at</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="printStatus()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>printStatus</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;printStatus()</pre>
<div class="block">Utility method to display the x co-ords</div>
</li>
</ul>
<a id="execute(java.lang.Object)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>execute</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;execute&#8203;(java.lang.Object&nbsp;parent)</pre>
<div class="block">A basic horizontal coordinate assignment algorithm</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="mxHierarchicalLayoutStage.html#execute(java.lang.Object)">execute</a></code>&nbsp;in interface&nbsp;<code><a href="mxHierarchicalLayoutStage.html" title="interface in import hk.quantr.mxgraph.layout.hierarchical.stage">mxHierarchicalLayoutStage</a></code></dd>
</dl>
</li>
</ul>
<a id="rankMedianPosition(int,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rankMedianPosition</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;rankMedianPosition&#8203;(int&nbsp;rankValue,
                                  <a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model,
                                  int&nbsp;nextRankValue)</pre>
<div class="block">Performs median minimisation over one rank.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>rankValue</code> - the layer number of this rank</dd>
<dd><code>model</code> - an internal model of the hierarchical layout</dd>
<dd><code>nextRankValue</code> - the layer number whose connected cels are to be laid out
            relative to</dd>
</dl>
</li>
</ul>
<a id="rankCoordinates(int,import hk.quantr.mxgraph.view.mxGraph,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rankCoordinates</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;rankCoordinates&#8203;(int&nbsp;rankValue,
                               <a href="../../../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                               <a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model)</pre>
<div class="block">Sets up the layout in an initial positioning. All the first cells in each
 rank are moved to the left and the rest of the rank inserted as close
 together as their size and buffering permits. This method works on just
 the specified rank.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>rankValue</code> - the current rank being processed</dd>
<dd><code>graph</code> - the facade describing the input graph</dd>
<dd><code>model</code> - an internal model of the hierarchical layout</dd>
</dl>
</li>
</ul>
<a id="calculateWidestRank(import hk.quantr.mxgraph.view.mxGraph,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>calculateWidestRank</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;calculateWidestRank&#8203;(<a href="../../../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                                   <a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model)</pre>
<div class="block">Calculates the width rank in the hierarchy. Also set the y value of each
 rank whilst performing the calculation</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>graph</code> - the facade describing the input graph</dd>
<dd><code>model</code> - an internal model of the hierarchical layout</dd>
</dl>
</li>
</ul>
<a id="minPath(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>minPath</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;minPath&#8203;(<a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model)</pre>
<div class="block">Straightens out chains of virtual nodes where possible</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>model</code> - an internal model of the hierarchical layout</dd>
</dl>
</li>
</ul>
<a id="repositionValid(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphAbstractHierarchyCell,int,double)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>repositionValid</h4>
<pre class="methodSignature">protected&nbsp;boolean&nbsp;repositionValid&#8203;(<a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model,
                                  <a href="../model/mxGraphAbstractHierarchyCell.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphAbstractHierarchyCell</a>&nbsp;cell,
                                  int&nbsp;rank,
                                  double&nbsp;position)</pre>
<div class="block">Determines whether or not a node may be moved to the specified x 
 position on the specified rank</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>model</code> - the layout model</dd>
<dd><code>cell</code> - the cell being analysed</dd>
<dd><code>rank</code> - the layer of the cell</dd>
<dd><code>position</code> - the x position being sought</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>whether or not the virtual node can be moved to this position</dd>
</dl>
</li>
</ul>
<a id="setCellLocations(import hk.quantr.mxgraph.view.mxGraph,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setCellLocations</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;setCellLocations&#8203;(<a href="../../../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                                <a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model)</pre>
<div class="block">Sets the cell locations in the facade to those stored after this layout
 processing step has completed.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>graph</code> - the facade describing the input graph</dd>
<dd><code>model</code> - an internal model of the hierarchical layout</dd>
</dl>
</li>
</ul>
<a id="adjustParents(java.util.Set)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>adjustParents</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;adjustParents&#8203;(java.util.Set&lt;java.lang.Object&gt;&nbsp;parentsChanged)</pre>
<div class="block">Adjust parent cells whose child geometries have changed. The default 
 implementation adjusts the group to just fit around the children with 
 a padding.</div>
</li>
</ul>
<a id="localEdgeProcessing(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>localEdgeProcessing</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;localEdgeProcessing&#8203;(<a href="../model/mxGraphHierarchyModel.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel</a>&nbsp;model)</pre>
<div class="block">Separates the x position of edges as they connect to vertices</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>model</code> - an internal model of the hierarchical layout</dd>
</dl>
</li>
</ul>
<a id="setEdgePosition(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphAbstractHierarchyCell)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setEdgePosition</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;setEdgePosition&#8203;(<a href="../model/mxGraphAbstractHierarchyCell.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphAbstractHierarchyCell</a>&nbsp;cell)</pre>
<div class="block">Fixes the control points</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>cell</code> - </dd>
</dl>
</li>
</ul>
<a id="setVertexLocation(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphAbstractHierarchyCell)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setVertexLocation</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;setVertexLocation&#8203;(<a href="../model/mxGraphAbstractHierarchyCell.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphAbstractHierarchyCell</a>&nbsp;cell)</pre>
<div class="block">Fixes the position of the specified vertex</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>cell</code> - the vertex to position</dd>
</dl>
</li>
</ul>
<a id="processReversedEdge(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyEdge,java.lang.Object)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>processReversedEdge</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;processReversedEdge&#8203;(<a href="../model/mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&nbsp;edge,
                                   java.lang.Object&nbsp;realEdge)</pre>
<div class="block">Hook to add additional processing</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>edge</code> - The hierarchical model edge</dd>
<dd><code>realEdge</code> - The real edge in the graph</dd>
</dl>
</li>
</ul>
<a id="getInterRankCellSpacing()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getInterRankCellSpacing</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;getInterRankCellSpacing()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the interRankCellSpacing.</dd>
</dl>
</li>
</ul>
<a id="setInterRankCellSpacing(double)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setInterRankCellSpacing</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setInterRankCellSpacing&#8203;(double&nbsp;interRankCellSpacing)</pre>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>interRankCellSpacing</code> - The interRankCellSpacing to set.</dd>
</dl>
</li>
</ul>
<a id="getIntraCellSpacing()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getIntraCellSpacing</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;getIntraCellSpacing()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the intraCellSpacing.</dd>
</dl>
</li>
</ul>
<a id="setIntraCellSpacing(double)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setIntraCellSpacing</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setIntraCellSpacing&#8203;(double&nbsp;intraCellSpacing)</pre>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>intraCellSpacing</code> - The intraCellSpacing to set.</dd>
</dl>
</li>
</ul>
<a id="getOrientation()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getOrientation</h4>
<pre class="methodSignature">public&nbsp;int&nbsp;getOrientation()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the orientation.</dd>
</dl>
</li>
</ul>
<a id="setOrientation(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setOrientation</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setOrientation&#8203;(int&nbsp;orientation)</pre>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>orientation</code> - The orientation to set.</dd>
</dl>
</li>
</ul>
<a id="getLimitX()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLimitX</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;getLimitX()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the limitX.</dd>
</dl>
</li>
</ul>
<a id="setLimitX(double)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setLimitX</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setLimitX&#8203;(double&nbsp;limitX)</pre>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>limitX</code> - The limitX to set.</dd>
</dl>
</li>
</ul>
<a id="isFineTuning()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isFineTuning</h4>
<pre class="methodSignature">public&nbsp;boolean&nbsp;isFineTuning()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the fineTuning.</dd>
</dl>
</li>
</ul>
<a id="setFineTuning(boolean)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>setFineTuning</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setFineTuning&#8203;(boolean&nbsp;fineTuning)</pre>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>fineTuning</code> - The fineTuning to set.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxCoordinateAssignment.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
<p class="legalCopy"><small><font size=1>Copyright (c) 2010 <a href="http://www.mxgraph.com/"
				target="_blank">Gaudenz Alder</a>. All rights reserved.</font></small></p>
</footer>
</body>
</html>
